<?php
/***********************************************************************
/                      PhotoAlbum SQL Personal Edition                 *
/			   Code (C) Dan Osipov			       *
/			  E-mail: dan@osipov.org                       *
/                                                                      *
/    This is a fully functional version. Please do not edit this code, *
/    unless you know what you are doing.                               *
/                                                                      *
/    Please make sure to give me some feedback on this program.        *
/    Visit my website at http://dan.osipov.org/photosql/               *
/                                                                      *
/    Structure of the program borrowed from Monster's Top List         *
/                                                                      *
/**********************************************************************/

new Lang;

class Lang {
	var $name_cach = array();
	var $langs = array();
	var $skin = "";

    function lang()
    {	global $pa, $admin;

		$this->langs = array(	'main' => '<b>Main Page</b><br>Edit the text apearing on the main page',
								'list' => '<b>List</b><br>Edit the main list page and search',
								'misc' => '<b>Miscellaneous</b><br>Miscellaneous language text for Ratings and other utilities',
                                'universal' => '<b>Universal</b><br>Edit text which is on multiple pages or global text',
		);

		$langs = explode("|", $pa->config['lang_names']);

		foreach($langs as $n)
		{	$new_lang = explode(":", $n);
			$id_cach[$new_lang[0]] = 'x';
			$this->name_cach[$new_lang[0]] = $new_lang[1];
		}

		switch($pa->input['op'])
		{	case 'managelang':
				$this->show_langs();
				break;
			case 'default':
				$this->do_default();
				break;
			case 'edit':
				$this->show_langs_files();
				break;
			case 'show':
				$this->show_langs_text();
				break;
			case 'do_lang':
				$this->do_langs();
				break;
			case 'del':
				$this->show_del();
				break;
			case 'do_del':
				$this->do_del();
				break;
			case 'add_lang':
				$this->add_lang();
				break;
			case 'rename_lang':
				$this->rename_lang();
				break;
			case 'export':
				$this->export();
				break;
			case 'download':
				$this->export_dl();
				break;
			case 'importlang':
				$this->show_import();
				break;
			case 'import_lang':
				$this->do_import();
				break;
			case 'upload':
				$this->show_upload();
				break;
			case 'upload_lang':
				$this->do_upload();
				break;
		}
	}

	function do_upload()
	{	global $admin, $pa, $DB, $root_path;

		$file = $pa->file("upload");

		if(!preg_match("/^lang_/", $file['name']) OR !preg_match("/.bak$/", $file['name']))
		{	$admin->error("That file is invalid.");	}

		$open = fopen($file['file'], 'r');
		$text = fread($open, filesize($file['file']));
		fclose($open);

		$this->do_import(1, $text);
	}

	function show_upload()
	{	global $admin, $pa, $DB, $root_path;

		$this->skin = $admin->add_top("Import/Upload Language Packs", "This page will allow you to import language packs from your computer hard drive.", "lang", "upload_lang", '0', "enctype='multipart/form-data'");
        $this->skin .= $admin->add_title("Import Language Pack", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("New Language Name:", "ie. 'Slang Pack' or 'French'"), $admin->add_form_textbox("name")), 1);
		$this->skin .= $admin->add_td_row(array(array("Select File:"), "<input type='file' name='upload' class='textinput'>"), 1);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Upload/Import Language');
		$admin->do_output($this->skin);
	}

	function do_import($read=0, $text="")
	{	global $admin, $pa, $DB, $root_path;

		if(!isset($pa->input['name']) OR $pa->input['name'] == "")
		{	$admin->error("You must enter a name for your new language."); 	}

		if(preg_match("/:/", $pa->input['name']) OR preg_match("/\|/", $pa->input['name']))
		{	$admin->error("':' or '|' cannot be entered in the language name.");	}


		if($read != 1)
		{	$open = fopen($root_path."tars/{$pa->input['pack']}", 'r');
			$text = fread($open, filesize($root_path."in/{$pa->input['pack']}"));
			fclose($open);
		}

		if(preg_match("/(fopen\((.*)\)|unlink\((.*)\)|require\((.*)\)|include\((.*)\)|mysql_(.*)\((.*)\)|DB-\>query\((.*)\))/is", $text))
		{	$admin->error("Sorry, it appears your Language Pack has been tampered with and may be dangerous to install.");	}

		$id = count($this->name_cach) + 1;

		if(!mkdir($root_path."lang/l{$new_id}", 0777))
		{	$admin->error("Unable to create directory, please make sure the directory 'lang' is CHMOD '777'.");	}

		@chmod($root_path."lang/l{$new_id}", 0777);

		$id = 0;	// Give each language file a new file name Number ID
		foreach($this->langs as $n => $v)
		{	$id++;
			$langs[$id] = $n;		}

		$id = 0;
		foreach($this->langs as $n => $v)
		{	$id++;

			$plus = $id + 1;

			$before = "\<!--".$langs[$id]."--\>";

			if(isset($langs[$plus]))
			{	$after = "\<!--".$langs[$plus]."--\>";	}

			$final = preg_replace("/(.*?)$before/si", "", $text);
			$final = preg_replace("/$after(.+)/si", "", $final);

			$open = fopen($root_path."lang/l{$new_id}/$langs[$id].php", 'w');
			fputs($open, $final, strlen($final));
			fclose($open);

			@chmod($root_path."lang/l{$new_id}/$langs[$id].php", 0777);
		}

		$this->name_cach[$new_id] = $pa->input['name'];

		foreach($this->name_cach as $n => $v)
		{	$save_lang[] = $n.":".$v;		}
		$langs = implode("|", $save_lang);

		$DB->query("UPDATE pa_config SET lang_names='$langs'");

		$admin->update("Language Imported Successfully", array("lang&op=edit&id=$new_id" => "Edit New Language", "lang&op=managelang" => 'Return to Main Languages'));

	}

	function show_import()
	{	global $admin, $pa, $root_path;

		$id = 0;
		$dir = opendir($root_path."tars/");
		while($filename = readdir($dir))
		{	if ($filename != "." AND $filename != "..")
			{	if(preg_match("/^lang_/", $filename))
  				{	$id++;
					$names[] = $filename;
				}
  			}
		}
		closedir($dir);

		$this->skin = $admin->add_top("Import Language Packs", "This page will allow you to import language packs from the 'tars' directory.<br><br><b><a href='admin.php?s={$pa->session}&act=lang&op=upload'>Upload a Language Pack</a></b>", "lang", "import_lang");
        $this->skin .= $admin->add_title("Import Language Pack", "2");
		$this->skin .= $admin->add_td_square("2");
		if($id == 0)
		{	$this->skin .= $admin->add_td_row(array("Sorry, no language packs can be found in the 'tars' directory."), 1);	}
		else {
		$this->skin .= $admin->add_td_row(array(array("New Language Name:", "ie. 'Slang Pack' or 'French'"), $admin->add_form_textbox("name")), 1);
		$this->skin .= $admin->add_td_row(array(array("Pack to Export:"), $admin->add_dropdown("pack", $names, 2)), 1);	}
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Import Language');
		$admin->do_output($this->skin);

	}

	function export_dl()
	{	global $pa, $root_path;

		$open = fopen($root_path."tars/{$pa->input['id']}", 'r');
		$final = fread($open, filesize($root_path."tars/{$pa->input['id']}"));
		fclose($open);

		header("Content-Type: text/plain");
		header("Content-Disposition: attachment; filename={$pa->input['id']}");
		header("Content-Length: " . strlen($final) . "");
		header("Content-Description: multipart-2");
		header("Pragma: no-cache");
		header("Expires: 0");
		header("Content-Transfer-Encoding: binary");

		print $final;
		exit;
	}

	function export()
	{	global $admin, $pa, $DB, $root_path;

		foreach($this->langs as $n => $v)
		{	$final .= "<!--$n-->";
			$file = fopen($root_path."lang/l{$pa->input['id']}/$n.php", r);
			$final .= fread($file, filesize($root_path."lang/l{$pa->input['id']}/$n.php"));
			fclose($file);
		}

		$name = "lang_".str_replace(" ", "_", $this->name_cach[$pa->input['id']]).".bak";

		$open = fopen($root_path."tars/$name", 'w');
		fputs($open, $final, strlen($final));
		fclose($open);

		$admin->update("Language Backed Up Successfully into 'out' directory", array("lang&op=download&id=$name" => "Download Language Pack", "lang&op=managelang" => 'Return to Main Languages'));

	}

	function do_del()
	{	global $admin, $pa, $DB;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That language cannot be found."); 	}

		if(count($this->name_cach) == 1)
		{	$admin->error("Sorry, you must have at least one language installed.");	}

		foreach($this->langs as $n => $v)
		{	unlink($root_path."lang/l{$pa->input['id']}/$n.php");	}

		rmdir($root_path."lang/l{$pa->input['id']}");

		foreach($this->name_cach as $n => $v)
		{	if($pa->input['id'] == $n)
			{	continue;	}
			if(!isset($save_skin)){	$safe_default = $n;	}
			$save_lang[] = $n.":".$v;		}
			$langs = implode("|", $save_lang);

		if($pa->config['lang_choice'] == $pa->input['id'])
		{	$default = ",lang_choice='$safe_default'";	}

		$DB->query("UPDATE pa_config SET lang_names='$langs'$default");

		$admin->update("Language Deleted Successfully", array("lang&op=managelang" => 'Return to Main Languages'));
	}

	function show_del()
	{	global $admin, $pa;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That language cannot be found."); 	}

		if(count($this->name_cach) == 1)
		{	$admin->error("Sorry, you must have at least one language installed.");	}

		$this->skin = $admin->add_top("Delete Language", "Use this page to delete a language", "lang", "do_del", '0');
        $this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
      	$this->skin .= $admin->add_title("Delete Language", "2");
        $this->skin .= $admin->add_td_square("1");
        $this->skin .= $admin->add_td_row(array("Are you sure you wish to delete <b>{$this->name_cach[$pa->input['id']]}</b>?"));
        $this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Delete Language');

		$admin->do_output($this->skin);
	}

	function rename_lang()
	{	global $admin, $pa, $DB;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That language cannot be found."); 	}

		if(!isset($pa->input['name']) OR $pa->input['name'] == "")
		{	$admin->error("You must enter a name for your new language."); 	}

		if(preg_match("/:/", $pa->input['name']) OR preg_match("/\|/", $pa->input['name']))
		{	$admin->error("':' or '|' cannot be entered in the language name.");	}

		foreach($this->name_cach as $n => $v)
		{	if($pa->input['id'] == $n)
			{	$v = $pa->input['name'];	}
			$save_lang[] = $n.":".$v;	}

		$langs = implode("|", $save_lang);
		$DB->query("UPDATE pa_config SET lang_names='$langs'");
		$admin->update("Language Renamed Successfully", array("lang&op=edit&id={$pa->input['id']}" => "Edit Same Language", "lang&op=managelang" => 'Return to Main Languages'));
	}

	function add_lang()
	{	global $admin, $pa, $DB, $root_path;

		if(!isset($pa->input['name']) OR $pa->input['name'] == "")
		{	$admin->error("You must enter a name for your new language."); 	}

		if(preg_match("/:/", $pa->input['name']) OR preg_match("/\|/", $pa->input['name']))
		{	$admin->error("':' or '|' cannot be entered in the language name.");	}

		$id = count($this->name_cach) + 1;

		if(!mkdir($root_path."lang/l{$id}", 0777))
		{	$admin->error("Unable to create directory, please make sure the directory 'lang' is CHMOD '777'.");	}

		@chmod($root_path."lang/l{$id}", 0777);

		foreach($this->langs as $n => $v)
		{	copy($root_path."lang/l{$pa->input['base']}/$n.php", $root_path."lang/l{$id}/$n.php");
			@chmod($root_path."lang/l{$id}/$n.php", 0777);
		}

		$this->name_cach[$id] = $pa->input['name'];

		foreach($this->name_cach as $n => $v)
		{	$save_lang[] = $n.":".$v;		}
		$langs = implode("|", $save_lang);

		$DB->query("UPDATE pa_config SET lang_names='$langs'");

		$admin->update("Language Added Successfully", array("lang&op=edit&id=$id" => "Edit New Language", "lang&op=managelang" => 'Return to Main Languages'));

	}

	function do_langs()
	{	global $admin, $pa, $root_path;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That language cannot be found."); 	}

		foreach($pa->input as $n => $v)
		{	if($n == "source" OR $n == "s" OR $n == "id" OR $n == "op" OR $n == "f" OR $n == "act" OR $n == "ip"){	continue;	}
			$new_lang[$n] = $v;
		}

		if($pa->input['f'] == "emails")
		{	$this->do_langs_emails();	}

		require ($root_path."lang/l{$pa->input['id']}/{$pa->input['f']}.php");

		if(count($lang) != count($new_lang))
		{	$admin->error("The amount of language text in the database is different to what was submited."); 	}

		asort($new_lang);

		$file = "<?php\n\n".'$lang '."= array (\n\n";
		foreach($new_lang as $n => $v)
		{	$file .= "'$n' => '$v',\n";	}
		$file .= "\n);\n\n?>";

		if ( $open = fopen( $root_path."lang/l{$pa->input['id']}/{$pa->input['f']}.php", 'w' ) )
		{	fputs($open, $file, strlen($file) );
		 	fclose($open);	}
		else
		{	$admin->error("Cannot edit language file, please make sure lang/l{$pa->input['id']}/{$pa->input['f']}.php is CHMOD 777");		}

		 $admin->update("Language File Updated Successfully", array("lang&op=show&id={$pa->input['id']}&f={$pa->input['f']}" => 'Return to edit this Language file again', "lang&op=edit&id={$pa->input['id']}" => 'Return to this Language\'s main editing screen', "lang&op=managelang" => 'Return to Manage Languages' ));
	}

	function do_langs_emails()
	{	global $admin, $pa, $root_path;

		foreach($pa->input as $n => $v)
		{	if($n == "source" OR $n == "s" OR $n == "id" OR $n == "op" OR $n == "f" OR $n == "act" OR $n == "ip"){	continue;	}
			$langs[$n] = stripslashes($v);
		}

		$mt = '$pa';
		foreach($langs as $n => $v)
		{	$v = preg_replace("/{(.*?)\.(.*?)\((.*?)\)}/is", "{".'$'."\\1->\\2['\\3']}", $v);

$file .= <<<data
function {$n}()
{	global $mt;
return <<<email
{$v}
email;
}

data;
	}
		$file = str_replace("\n", "", $file);
		$file = str_replace("email;", "\nemail;", $file);
		$file = "<?php\n\n$file\n\n?>";

		if ( $fo = fopen( $root_path."lang/l{$pa->input['id']}/{$pa->input['f']}.php", 'w' ) )
		{	fputs($fo, $file, strlen($file) );
			fclose($fo);	}
		else
		{	$admin->error("Cannot edit language file, please make sure lang/l{$pa->input['id']}/{$pa->input['f']}.php is CHMOD 777");		}

		$admin->update("Language File Updated Successfully", array("lang&op=show&id={$pa->input['id']}&f={$pa->input['f']}" => 'Return to edit this Language file again', "lang&op=edit&id={$pa->input['id']}" => 'Return to this Language\'s main editing screen', "lang&op=managelang" => 'Return to Manage Languages' ));
	}

	function show_langs_emails()
	{	global $admin, $pa, $root_path;

		$open = fopen($root_path."lang/l{$pa->input['id']}/emails.php", 'r');
		$text = fread($open, filesize($root_path."lang/l{$pa->input['id']}/emails.php"));
		fclose($open);

		$text = preg_replace("/(\<\?php|\?\>)/", "", $text);
		$text = preg_replace("/{".'\$(.*?)'."->(.*?)\['(.*?)'\]}/is", "{\\1.\\2(\\3)}", $text);

		$sections = array('info_send_user', 'acc_account', 'new_user_email', 'revalidate', 'new_user_admin', 'forget_pw');

		foreach($sections as $v)
		{	$final[$v] = preg_replace("/(.*?)function {$v}(.*?)<<<email(.*?)email;(.*)/is", "\\3", $text);
			$final[$v] = preg_replace("/(\r|\n)$/", "", $final[$v]);
		}

		$this->skin = $admin->add_top("Edit Language Packs", "Select which area you wish to edit", "lang", 'do_lang');
		$this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
	    $this->skin .= $admin->add_form_hidden("f", $pa->input['f']);
		$this->skin .= $admin->add_title("Edit Languages - {$this->name_cach[$pa->input['id']]} - {$pa->input['f']}", "2");
        $this->skin .= $admin->add_td_square("2");
		foreach($final as $n => $v)
		{	$this->skin .= $admin->add_td_row(array("<b>$n</b>", $admin->add_form_textarea("$n", $v, '8')), 2);	}

		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Edit Language');
        $admin->do_output($this->skin);

	}

	function show_langs_text()
	{	global $admin, $pa, $root_path;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That language cannot be found."); 	}

		if($pa->input['f'] == "emails")
		{	$this->show_langs_emails();	}

		require ($root_path."lang/l{$pa->input['id']}/{$pa->input['f']}.php");

		asort($lang);

		$this->skin = $admin->add_top("Edit Language Packs", "Select which area you wish to edit", "lang", 'do_lang');
		$this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
	    $this->skin .= $admin->add_form_hidden("f", $pa->input['f']);
		$this->skin .= $admin->add_title("Edit Languages - {$this->name_cach[$pa->input['id']]} - {$pa->input['f']}", "2");
        $this->skin .= $admin->add_td_square("2");
		foreach($lang as $n => $v)
		{	$this->skin .= $admin->add_td_row(array("<b>$n</b>", $admin->add_form_textarea("$n", stripslashes($v), '3')), 2);	}

		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Edit Language');
        $admin->do_output($this->skin);

	}

	function show_langs_files()
	{	global $admin, $pa;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That language cannot be found."); 	}

		$this->skin = $admin->add_top("Edit Language Packs", "Select which area you wish to edit", "lang", "rename_lang");
        $this->skin .= $admin->add_title("Edit Languages - {$this->name_cach[$pa->input['id']]}", "2");
        $this->skin .= $admin->add_td_square("2");

		foreach($this->langs as $n => $v)
		{	$this->skin .= $admin->add_td_row(array("$v", "<a href='admin.php?s={$pa->session}&act=lang&op=show&id={$pa->input['id']}&f=$n'>Edit</a>"), 4);	}
		$this->skin .= $admin->end_td_square();

		$this->skin .= $admin->add_title("Rename Language", "2");
		$this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("New Language Name:", "ie. 'Slang Pack' or 'French'"), $admin->add_form_textbox("name", $this->name_cach[$pa->input['id']])), 1);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Rename Language');

        $admin->do_output($this->skin);
	}

	function do_default()
	{	global $pa, $admin, $DB;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That language cannot be found."); 	}

		$DB->query("UPDATE pa_config SET lang_choice='{$pa->input['id']}'");

		$admin->update("Default Language Changed Successfully", array("lang&op=managelang" => 'Return to Main Languages'));
	}

	function show_langs()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("Manage Language Packs", "This page will allow you to add, edit or remove language packs.", "lang", "add_lang");
        $this->skin .= $admin->add_title("Edit Languages", "2");
        $this->skin .= $admin->add_td_square("2");

		foreach($this->name_cach as $n => $v)
		{	if($pa->config['lang_choice'] == $n)
			{	$default = "<b>Current Default Lang</b>";	}
			else	{	$default = "<a href='admin.php?s={$pa->session}&act=lang&op=default&id=$n'>Make Default Lang</a>";	}

			$this->skin .= $admin->add_td_row(array("<b>$v</b>", "$default | <a href='admin.php?s={$pa->session}&act=lang&op=edit&id=$n'>Edit</a> | <a href='admin.php?s={$pa->session}&act=lang&op=del&id=$n'>Delete</a> | <a href='admin.php?s={$pa->session}&act=lang&op=export&id=$n'>Export</a>"), 2);
		}

		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_title("Add Language", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("New Language Name:", "ie. 'Slang Pack' or 'French'"), $admin->add_form_textbox("name")), 1);
		$this->skin .= $admin->add_td_row(array(array("Base Language On:"), $admin->add_dropdown("base", $this->name_cach, 1)), 1);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Add Language');
		$admin->do_output($this->skin);
	}

}

?>