<?php
/***********************************************************************
/                      PhotoAlbum SQL Personal Edition                 *
/			   Code (C) Dan Osipov			       *
/			  E-mail: dan@osipov.org                       *
/                                                                      *
/    This is a fully functional version. Please do not edit this code, *
/    unless you know what you are doing.                               *
/                                                                      *
/    Please make sure to give me some feedback on this program.        *
/    Visit my website at http://dan.osipov.org/photosql/               *
/                                                                      *
/    Structure of the program borrowed from Monster's Top List         *
/                                                                      *
/**********************************************************************/

new Misc;

class Misc {
    function misc()
    {	global $pa, $admin;

		switch($pa->input['op'])
		{	case 'comm':
				$this->show_comm();
				break;
			case 'search_comm':
				$this->search_comm();
				break;
			case 'show_comm_list':
				$this->show_comm_list();
				break;
			case 'edit_comm':
				$this->edit_comm();
				break;
			case 'do_comm':
				$this->do_comm();
				break;
			case 'del_comm':
				$this->show_del();
				break;
			case 'do_comm_del':
				$this->do_comm_del();
				break;
			case 'faqs':
				$this->show_faqs();
				break;
			case 'edit_faqs':
				$this->edit_faqs('Edit');
				break;
			case 'add_faqs':
				$this->edit_faqs('Add');
				break;
			case 'do_faqs_edit':
				$this->do_faqs_edit();
				break;
			case 'do_faqs_add':
				$this->do_faqs_add();
				break;
			case 'del_faqs':
				$this->del_faqs();
				break;
			case 'do_faqs_del':
				$this->do_faq_del();
				break;
			case 'admin':
				$this->show_admin();
				break;
			case 'add_admin':
				$this->add_admin();
				break;
			case 'edit_admin':
				$this->edit_admin();
				break;
			case 'do_admin':
				$this->do_admin();
				break;
			case 'del_admin':
				$this->show_admin_del();
				break;
			case 'do_admin_del':
				$this->do_admin_del();
				break;
            case 'cont':
            	$this->contact();
                break;
            case 'do_cont':
            	$this->do_contact();
                break;
		}
	}

	function show_comm()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("Search for a picture to Edit Comments", "Use the below form to search for a photo, once the photo is found a list of comments for the photo will be shown.", "misc", 'search_comm');
        $this->skin .= $admin->add_title("Search Terms", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Photo ID:"), $admin->add_form_textbox("id")), 1);
        $this->skin .= $admin->add_td_row(array(array("Name:"), $admin->add_form_textbox("name")), 1);
        $this->skin .= $admin->add_td_row(array(array("Description:"), $admin->add_form_textbox("desc")), 1);
        //$this->skin .= $admin->add_td_row(array(array("E-Mail Address:"), $admin->add_form_textbox("email")), 1);
        //$this->skin .= $admin->add_td_row(array(array("Site Name:"), $admin->add_form_textbox("site_name")), 1);
        //$this->skin .= $admin->add_td_row(array(array("Site URL:"), $admin->add_form_textbox("site_url")), 1);
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Search');
        $admin->do_output($this->skin);
	}

	function search_comm()
	{	global $pa, $admin, $DB;

		$query = "SELECT id,name,description FROM pa_pictures WHERE ";
        if ($pa->input['id'] != "") $query_array[] = "id='" .$pa->input['id'] . "' ";
	    if ($pa->input['name'] != "") $query_array[] = "LOWER(name) LIKE '" . strtolower($pa->input['name']) . "%' ";
        if ($pa->input['desc'] != "") $query_array[] = "desc LIKE '" . $pa->create_ip($pa->input['desc']) . "' ";
        //if ($pa->input['email'] != "") $query_array[] = "LOWER(email) LIKE '" . strtolower($pa->input['email']) . "%' ";
        //if ($pa->input['site_name'] != "") $query_array[] = "LOWER(site_name) LIKE '%" . strtolower($pa->input['site_name']) . "%' ";
        //if ($pa->input['site_url'] != "") $query_array[] = "LOWER(site_url) LIKE '%" . strtolower($pa->input['site_url']) . "%' ";

        if (!isset($query_array)) {
            $admin->error("You must enter at least one search term");
        }

        $query .= implode(" OR ", $query_array);
		$query .= " ORDER BY id ASC";
        $DB->query($query);

        if ($DB->count() == 0) {
            $admin->error("No photographs can be found with those search terms. Please try another search again.");
        }

		if ($DB->count() == '1') {
            $r = $DB->fetch_row();
            $pa->input['user'] = $r['id'];
            $this->show_comm_list();
        }

		$this->skin = $admin->add_top("Searching Photographs", "Select the photograph which you wish to edit the comments of.", "misc", 'show_comm_list');
        $this->skin .= $admin->add_title("Search Results", "2");
        $this->skin .= $admin->add_td_square("2");

        while ($r = $DB->fetch_row()) {
            $this->skin .= $admin->add_td_row(array($admin->add_form_radio('user', $r['id'], 1), $r['name'] . " <i>($r[desc])</i>"), 3);
        }

        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end("Show Comments");
        $admin->do_output($this->skin);
	}

	function show_comm_list()
	{	global $pa, $admin, $DB;

		$DB->query("SELECT id,name FROM pa_pictures WHERE id='".$pa->input['user']."'");

		if ($DB->count() != 1) {
            $admin->error("That account cannot be found");
        }

		$DB->query("SELECT * FROM pa_comments WHERE pic_id=".$pa->input['user']."");

		if ($DB->count() == 0) {
            $admin->error("This photograph has no comments");
        }

		$this->skin = $admin->add_top("Edit Comments", "Click Edit or Remove to modify the comments listed below.");
        $this->skin .= $admin->add_title("Comment Listings", "2");
        $this->skin .= $admin->add_td_square("2");

        while ($r = $DB->fetch_row()) {

			if($pa->check_email($r['email'], 1))
			{	$r['email'] = $r['name'];	}
			else
			{	$r['email'] = "<a href='mailto:".$r['email']."'>".$r['name']."</a>"; 	}

			$r['message'] = stripslashes($r['message']);
			$r['date'] = $pa->date($r['date'], 'mid');

        	$this->skin .= $admin->add_td_row(array("<b>Comments by $r[email] on $r[date]</b><br>$r[message]<br><br>", "<a href='admin.php?s={$pa->session}&act=misc&op=edit_comm&id=$r[id]'>Edit</a> | <a href='admin.php?s={$pa->session}&act=misc&op=del_comm&id=$r[id]'>Delete</a>"), 4);

		}

        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end();
        $admin->do_output($this->skin);
	}

	function edit_comm()
	{	global $pa, $admin, $DB;

		$DB->query("SELECT message,name,email,pic_id FROM pa_comments WHERE id=".$pa->input['id']."");

		if ($DB->count() < 0) {
            $admin->error("That comment cannot be found.");
        }

		$r = $DB->fetch_row();

		$this->skin = $admin->add_top("Edit Comment", "Edit comments using the form below.", "misc", 'do_comm');
        $this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
	    $this->skin .= $admin->add_form_hidden("pic", $r['pic_id']);
		$this->skin .= $admin->add_title("Edit Comment", "2");
        $this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("Name:"), $admin->add_form_textbox("name", $r["name"])), 1);
        $this->skin .= $admin->add_td_row(array(array("E-Mail:"), $admin->add_form_textbox("email", $r["email"])), 1);
    	$this->skin .= $admin->add_td_row(array(array("Message:"), $admin->add_form_textarea("message", $r["message"]),), 1);
		$this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Edit Comment');
        $admin->do_output($this->skin);
	}

	function do_comm()
	{	global $pa, $admin, $DB;

		$message = addslashes($pa->input['message']);
		$name = addslashes($pa->input['name']);
		$email = addslashes($pa->input['email']);

		$DB->query("UPDATE pa_comments SET message='$message',email='$email',name='$name' WHERE id='{$pa->input['id']}'");
		$admin->update("Comment Updated Successfully", array("misc&op=edit_comm&id={$pa->input['id']}" => 'Edit Same Comment', "misc&op=show_comm_list&user={$pa->input['pic']}" => 'Edit Same Account Comments', 'misc&op=comm' => 'Search for More Comments'));
	}

	function show_del()
    {	global $pa, $admin, $DB;

		$DB->query("SELECT id,name,email,pic_id FROM pa_comments WHERE id='" . $pa->input['id'] . "'");

        if ($DB->count() != 1) {	$admin->error("This comment cannot be found"); 	}

        $row = $DB->fetch_row();

		if($pa->check_email($row['email'], 1))
		{	$row['email'] = $row['name'];	}
		else
		{	$row['email'] = "<a href='mailto:".$row['email']."'>".$row['name']."</a>"; 	}

        $this->skin = $admin->add_top("Delete Comment", "Use this page to delete a comment", "misc", "do_comm_del", '0');
        $this->skin .= $admin->add_form_hidden("id", $row['id']);
      	$this->skin .= $admin->add_form_hidden("pic", $r['pic_id']);
	    $this->skin .= $admin->add_title("Delete Comment", "2");
        $this->skin .= $admin->add_td_square("1");
        $this->skin .= $admin->add_td_row(array("Are you sure you wish to delete <b>$row[email]'s</b> comment?"));
        $this->skin .= $admin->end_td_square();

        $this->skin .= $admin->add_end('Delete Comment');
        $admin->do_output($this->skin);
    }

	function do_comm_del()
	{	global $pa, $admin, $DB;

		$DB->query("DELETE FROM pa_comments WHERE id='{$pa->input['id']}'");
		$admin->update("Comment Deleted Successfully", array("misc&op=show_comm_list&user={$pa->input['pic']}" => 'Edit Same Photograph\'s Comments', 'misc&op=comm' => 'Search for More Comments'));
	}

    function contact()
    {
		global $admin, $pa;

        $this->skin = $admin->add_top("Contact Me", "Use this page to report an error, suggest a feature, or say anything you wish to me.", "misc", "do_cont", '0');
      	$this->skin .= $admin->add_title("Fill in This Form", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Subject:"), $admin->add_dropdown("subj", array("error" => "Report error", "news" => "Subscribe to PhotoAlbum SQL news", "feature" => "Suggest feature", "question" => "Ask a question", "other" => "Other"))), 1);
        $this->skin .= $admin->add_td_row(array(array("Message:"), $admin->add_form_textarea("message")), 1);
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Send');
        $admin->do_output($this->skin);
    }

    function do_contact()
    {
    global $admin, $pa;
    $info = array("to_name" => "PhotoAlbum SQL", "to_mail" => "photosql@osipov.org", "subject" => $pa->input['subj'], "message" => $pa->input['message']);

    $info['message'] .= "\n\n" . $pa->config['pasql_url'] . "\n" . $pa->config['pasql_email'];

    $pa->mailer($info);

    $admin->update("Message Sent", array('misc&op=admin' => 'Admin Account Screen'));
    }
}

?>