<?php
/***********************************************************************
/                      PhotoAlbum SQL Personal Edition                 *
/			   Code (C) Dan Osipov			       *
/			  E-mail: dan@osipov.org                       *
/                                                                      *
/    This is a fully functional version. Please do not edit this code, *
/    unless you know what you are doing.                               *
/                                                                      *
/    Please make sure to give me some feedback on this program.        *
/    Visit my website at http://dan.osipov.org/photosql/               *
/                                                                      *
/    Structure of the program borrowed from Monster's Top List         *
/                                                                      *
/**********************************************************************/

new Index;

class Index {
    function index()
    {
        global $pa, $admin;

        switch ($pa->input['op']) {
		case 'do_settings':
			$this->do_settings();
			break;
		case 'list':
			$this->show_list();
			break;
        case 'gen':
            $this->show_general();
            break;
		case 'reg':
			$this->show_reg();
			break;
		case 'codes':
			$this->show_code();
			break;
		case 'images':
			$this->show_images();
			break;
		case 'update':
			$this->show_update();
			break;
		case 'do_updates':
			$this->do_update();
			break;
		case 'update_run':
			$this->show_upd_run();
			break;
		case 'do_upd_run':
			$this->do_upd_run();
			break;
		case 'date':
			$this->show_datetime();
			break;
		case 'cookies':
			$this->show_cookies();
			break;
		case 'onoff':
			$this->show_onoff();
			break;
		default:
			$admin->error("You have tried to use this file incorrectly. Please click a contents item on the left and try again.");
			break;
	}
	}

	function show_general()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("General Settings", "Edit General Settings below. When you are done, press 'Edit Settings'.", "set", "do_settings");
		$this->skin .= $admin->add_title("Input Information", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("Album Name:", "ie. 'PhotoAlbum'"), $admin->add_form_textbox("pasql_name", $pa->config["pasql_name"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Album Url:", "ie. 'http://yahoo.com'"), $admin->add_form_textbox("pasql_url", $pa->config["pasql_url"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Album Owner:", "Used as the name of where e-mails come from"), $admin->add_form_textbox("pasql_owner_name", $pa->config["pasql_owner_name"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Album Owner E-Mail:", "The e-mail address which e-mails come from"), $admin->add_form_textbox("pasql_owner_email", $pa->config["pasql_owner_email"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("E-Mail Signature:", "A message which will appear on every e-mail sent from the boards."), $admin->add_form_textarea("email_sig", $pa->config["email_sig"]),), 1);
		$this->skin .= $admin->add_td_row(array(array("Session Time:", "How long a users session for User CP/Admin CP will be stored in the database. This is in seconds, default is 3600 (an hour)."), $admin->add_form_textbox("session_time", $pa->config["session_time"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Enable GZIP:", "Minimizes page size when sent to browser to save bandwidth and make pages load quicker."), $admin->add_form_radio("enable_gzip", $pa->config["enable_gzip"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Max Server Load:", "If on a Unix server set a server load when the list should automatically close until the server clears system resources."), $admin->add_form_textbox("max_load", $pa->config["max_load"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Selectable Languages:", "Have a drop down list at the bottom right corner with selectable languages"), $admin->add_form_radio("lang_selectable", $pa->config["lang_selectable"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Selectable Skins:", "Have a drop down list at the bottom right corner with selectable skins"), $admin->add_form_radio("skin_selectable", $pa->config["skin_selectable"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Debug Level One:", "Show Page Generation Time, Unix Time, List Updates, Query Count etc in the footer of each page"), $admin->add_form_radio("debug_1", $pa->config["debug_1"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Debug Level Two:", "Show Database Queries in the footer of each page"), $admin->add_form_radio("debug_2", $pa->config["debug_2"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Debug Level Three:", "Show POST/GET Values in the footer of each page"), $admin->add_form_radio("debug_3", $pa->config["debug_3"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Print Header Tags:", "This may cause errors with Windows, but is recommended for other systems"), $admin->add_form_radio("header_show", $pa->config["header_show"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Print Header Cach Tags:", "If the above option is 'Yes'; Do not allow the browser to cach pages."), $admin->add_form_radio("header_cach", $pa->config["header_cach"])), 1);
		$this->skin .= $admin->add_td_row(array(array("NT Savvy Redirects", "Although this is <u>not recommended</u> for ANY systems, it will change the default instant redirection to a page in between, this will fix redirection errors. (If there are any)"), $admin->add_form_radio("header_nt", $pa->config["header_nt"])), 1);
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Edit Settings');
        $admin->do_output($this->skin);

	}

	function show_list()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("List Settings", "Edit List Settings below. When you are donepress 'Edit Settings'.", "set", "do_settings");
		$this->skin .= $admin->add_title("Input Information", "2");
		$this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Photograph directory:", "Web directory where photographs will be stored. Default: pic/"), $admin->add_form_textbox("pic_path", $pa->config["pic_path"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Photograph location:", "HTTP link for the directory above where photographs are located"), $admin->add_form_textbox("pic_http", $pa->config["pic_http"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Thumbnail Width:", "Maximum pixel width of created thumbnail"), $admin->add_form_textbox("tn_width", $pa->config["tn_width"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Thumbnail Height:", "Maximum pixel height of created thumbnail"), $admin->add_form_textbox("tn_height", $pa->config["tn_height"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Gallery Order:", "This is the default order, users can choose an order to view (but will not be permanent)."), $admin->add_dropdown("list_order", array("viewed" => "Viewed", "rating" => "Rating", "date" => "Date"), $pa->config["list_order"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Photos per row:", "Number of photographs on each row"), $admin->add_form_textbox("pics_per_row", $pa->config["pics_per_row"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Photos per column:", "Number of photographs on each column"), $admin->add_form_textbox("pics_per_col", $pa->config["pics_per_col"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Categories per row:", "Number of categories on each row"), $admin->add_form_textbox("categ_per_row", $pa->config["categ_per_row"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("Fill Rows Up:", "If you have 50 pages in the list but only 25 are registered, fill up the rest with 'Signup' links."), $admin->add_form_radio("rows_fill_up", $pa->config["rows_fill_up"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("Top Sites with Banners:", "Top '10' sites have banners showing. Set to 0 to disable all banners."), $admin->add_form_textbox("rows_banner", $pa->config["rows_banner"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("Show Up/Steady/Down Images:", "Images to show if a site is higher or lower then the saved records next to position numbers."), $admin->add_form_radio("list_updown", $pa->config["list_updown"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("Top Seperation:", "Seperate top '10' sites, perhaps for an ad banner.  '0' to disable. This is edited in Skin Templates."), $admin->add_form_textbox("sep_top", $pa->config["sep_top"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("Regular Seperation:", "Seperate every '15' sites, perhaps for a regular ad banner, this is for after the special top sperator. '0' to disable. This is edited in Skin Templates."), $admin->add_form_textbox("sep_regular", $pa->config["sep_regular"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("Allow List Hiding:", "Allow users to self-hide themselves from the list."), $admin->add_form_radio("enable_userhide", $pa->config["vote_gateway"])), 1);
		//$this->skin .= $admin->add_td_row(array(array("Enable Gateway:", "Enable a gateway screen prior to voting being counted, this stops sites from forcing users to vote."), $admin->add_form_radio("vote_gateway", $pa->config["vote_gateway"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Enable Comments:", "Enable the comments system in the information panel"), $admin->add_form_radio("enable_comments", $pa->config["enable_comments"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Append Comments:", "Add comment form to the bottom of image display page"), $admin->add_form_radio("append_comments", $pa->config["append_comments"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Enable Viewed Counting:", "Do you wish to count how many times pictures have been viewed?"), $admin->add_form_radio("enable_viewed", $pa->config["enable_viewed"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Enable Ratings:", "Do you wish to allow users to rate photographs?"), $admin->add_form_radio("enable_rating", $pa->config["enable_rating"])), 1);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Edit Settings');
        $admin->do_output($this->skin);
    }

	function show_datetime()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("Date & Time Settings", "Edit Date & Time Settings below. When you are donepress 'Edit Settings'.", "set", "do_settings");
		$this->skin .= $admin->add_title("Input Information", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("Time Adjustment (Hours):", "<b>List time: ".$pa->date(time(), 'long')."</b>.<br>+ or - hours in the textbox."), $admin->add_form_textbox("date_adjust", $pa->config["date_adjust"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Time Adjustment (Minutes):", "+ or - minutes in the textbox."), $admin->add_form_textbox("date_adjust2", $pa->config["date_adjust2"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Short Date:", "Refer to <a href='http://www.php.net/manual/en/function.date.php' target='_blank'>PHP Date</a> function"), $admin->add_form_textbox("date_short", $pa->config["date_short"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Medium Date:", "Refer to <a href='http://www.php.net/manual/en/function.date.php' target='_blank'>PHP Date</a> function"), $admin->add_form_textbox("date_mid", $pa->config["date_mid"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Long Date:", "Refer to <a href='http://www.php.net/manual/en/function.date.php' target='_blank'>PHP Date</a> function"), $admin->add_form_textbox("date_long", $pa->config["date_long"])), 1);
		$this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Edit Settings');
        $admin->do_output($this->skin);

	}

	function show_cookies()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("Cookie Settings", "Edit Cookie Settings below. None of these settings are required. When you are donepress 'Edit Settings'.", "set", "do_settings");
		$this->skin .= $admin->add_title("Input Information", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("Cookie Name:", "Prefix for all cookies created by this list."), $admin->add_form_textbox("cookie_name", $pa->config["cookie_name"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Cookie Time:", "For general cookies, how long should they last. Does not refer to Vote In/Out system or User CP."), $admin->add_form_textbox("cookie_time", $pa->config["cookie_time"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Cookie Path:", "The path of your list, ie /scripts if it is http://www.domain.com/scripts/"), $admin->add_form_textbox("cookie_path", $pa->config["cookie_path"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Cookie Domain:", "Your list domain"), $admin->add_form_textbox("cookie_domain", $pa->config["cookie_domain"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Secure Coookie:", "Make your cookies secure by not allowing access to them from some URLs, this is not recommended."), $admin->add_form_radio("cookie_secure", $pa->config["cookie_secure"])), 1);
		$this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Edit Settings');
        $admin->do_output($this->skin);
	}

	function show_onoff()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("Cookie Settings", "Edit Cookie Settings below. None of these settings are required. When you are donepress 'Edit Settings'.", "set", "do_settings");
		$this->skin .= $admin->add_title("Input Information", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("Turn List On:", "Make the list innaccesible by turning the list off."), $admin->add_form_radio("status", $pa->config["status"])), 1);
		$this->skin .= $admin->add_td_row(array(array("Reason for being Off:", "This is the explanation which will be provided to visitors on the closure."), $admin->add_form_textarea("status_reason", $pa->config["status_reason"]),), 1);

		$this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Edit Settings');
        $admin->do_output($this->skin);
	}

	function do_update()
	{	global $DB, $pa, $admin;

		$update['update_fromlast'] = $pa->input['update_fromlast'];
		// It requires less coding if we use a foreach() with an array then write the code out 6 times...
		$updates = array (	'votes', 'votesout', 'rating', 'votesall', 'votesoutall', 'ratingall'	);

		foreach($updates as $n)
		{	if(!is_numeric($pa->input[$n.'_time_1']) OR !is_numeric($pa->input[$n.'_time_2']))
			{	$admin->error("All data placed into the update text boxes must be numeric, please return to the previous page and try again.");	}

			$update['update_'.$n] = $pa->input['update_'.$n];
			$update['update_'.$n.'_last '] = strtotime("".$pa->input[$n.'_date']." ".$pa->input[$n.'_month']." ".$pa->input[$n.'_year']." ".$pa->input[$n.'_hour'].":".$pa->input[$n.'_min'].$pa->input[$n.'_pf']) + $pa->time;
			$update['update_'.$n.'_time'] = $this->conv_update($pa->input[$n.'_time_1'], $pa->input[$n.'_time_2'], $pa->input[$n.'_time_3']);

			$update['update_'.$n.'_time_acp'] = $pa->input[$n.'_time_1'].",".$pa->input[$n.'_time_2'].",".$pa->input[$n.'_time_3'];	}

			$this->do_settings($update);
	}
    /*
	function show_upd_run()
	{	global $admin;

		$this->skin = $admin->add_top("Run Updates", "Manually run updates on your list, <b><u>You will need to reset your Automatic Update Settings if you run this, they will be turned off!</b></u>. This only applies to those which you select 'Yes' to.", "set", "do_upd_run");
		$this->skin .= $admin->add_title("Input Information", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("Update Votes:", "Allow users to vote again."), $admin->add_form_radio("votes", 0)), 1);
		$this->skin .= $admin->add_td_row(array(array("Update Votes Out:", "Allow users to vote out again."), $admin->add_form_radio("votesout", 0)), 1);
		$this->skin .= $admin->add_td_row(array(array("Update Rating:", "Allow users to rate again."), $admin->add_form_radio("rating", 0)), 1);
		$this->skin .= $admin->add_td_row(array(array("Update Votes All:", "Allow users to vote again and also set 'Votes' to 0."), $admin->add_form_radio("votesall", 0)), 1);
		$this->skin .= $admin->add_td_row(array(array("Update Votes Out All:", "Allow users to vote out again and also set 'Votes Out' to 0."), $admin->add_form_radio("votesoutall", 0)), 1);
		$this->skin .= $admin->add_td_row(array(array("Update Rating All:", "Allow users to rate again and also set 'Rating' to Unrated (0)."), $admin->add_form_radio("ratingall", 0)), 1);
		$this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Run Now');
        $admin->do_output($this->skin);
	}
    */
	function do_upd_run()
	{	global $pa, $admin, $DB;

		$time = round((time() + $pa->time)/60, 0)*60 ;

		if($pa->input['votesall'] == 1)
		{	$config_query[] = "update_votes_last='$time'";
			$config_query[] = "update_votesall_last='$time'";
			$config_query[] = "update_votesall='0'";
			$config_query[] = "update_votes='0'";
			$sites_query[] = "votes_users=''";
			$sites_query[] = "votes_past=votes";
			$sites_query[] = "votes='0'";
		}
		else if($pa->input['votes'] == 1)
		{	$config_query[] = "update_votes_last='$time'";
			$config_query[] = "update_votes='0'";
			$sites_query[] = "votes_users=''";
		}

		if($pa->input['votesoutall'] == 1)
		{	$config_query[] = "update_votesout_last='$time'";
			$config_query[] = "update_votesoutall_last='$time'";
			$config_query[] = "update_votesoutall='0'";
			$config_query[] = "update_votesout='0'";
			$sites_query[] = "votesout_users=''";
			$sites_query[] = "votesout_past=votes";
			$sites_query[] = "votesout='0'";
		}
		else if($pa->input['votesout'] == 1)
		{	$config_query[] = "update_votesout_last='$time'";
			$config_query[] = "update_votesout='0'";
			$sites_query[] = "votesout_users=''";
		}

		if($pa->input['ratingall'] == 1)
		{	$config_query[] = "update_rating_last='$time'";
			$config_query[] = "update_ratingall_last='$time'";
			$config_query[] = "update_ratingall='0'";
			$config_query[] = "update_rating='0'";
			$sites_query[] = "rating_users=''";
			$sites_query[] = "rating_total=''";
			$sites_query[] = "rating=''";
			$sites_query[] = "rating_past=rating/rating_total";
		}
		else if($pa->input['rating'] == 1 )
		{	$config_query[] = "update_rating_last='$time'";
			$config_query[] = "update_rating='0'";
			$sites_query[] = "rating_users=''";
		}

		if(isset($sites_query))
		{	$this->update = 1;
			$sites_query = implode(",", $sites_query);
			$DB->query("UPDATE pa_users SET $sites_query");	}

		if(isset($config_query))
		{	$this->update = 1;
			$config_query = implode(",", $config_query);
			$DB->query("UPDATE pa_config SET $config_query WHERE id='".$DB->config['5']."'");	}

		 $admin->update("Manual List Update Processed", array("set&op=update_run" => 'Return to Run Updates'));

	}

	function conv_update($happen, $every, $time)
	{	switch($time)
		{	case 'hour':	$secs = 3600;				break;
			case 'day':		$secs = 3600*24;			break;
			case 'week':	$secs = 3600*24*7;			break;
			case 'months':	$secs = 3600*24*30;			break;
			case 'year':	$secs = 3600*24*365;		break;
		}

		return ($secs * $every)/$happen;
	}

	function do_settings($update='')
	{	global $DB, $pa, $admin;

		if(is_array($update))	{	$input = $update;	}
		else	{$input = $pa->input;	}

		foreach($input as $n => $v)
		{	if($n == "code" OR $n == "source" OR strlen($n) <= 3)	continue;
			else	$update[$n] = $v;
		}

		$DB->query("UPDATE pa_config SET ".$DB->update($update)." WHERE id='".$DB->config[5]."'");

		$admin->update("Settings Updated Successfully");
	}
}

?>