<?php
/***********************************************************************
/                      PhotoAlbum SQL Personal Edition                 *
/			   Code (C) Dan Osipov			       *
/			  E-mail: dan@osipov.org                       *
/                                                                      *
/    This is a fully functional version. Please do not edit this code, *
/    unless you know what you are doing.                               *
/                                                                      *
/    Please make sure to give me some feedback on this program.        *
/    Visit my website at http://dan.osipov.org/photosql/               *
/                                                                      *
/    Structure of the program borrowed from Monster's Top List         *
/                                                                      *
/**********************************************************************/

new Index;

class Index {
    function index()
    {
        global $pa, $admin;

        switch ($pa->input['op']) {
            case 'reg':
                $this->show_reg();
                break;
            case 'do_reg':
                $this->do_reg();
                break;
            case 'edit':
                $this->show_search('do_edit_search', 'Edit');
                break;
            case 'do_edit_search':
                $this->find_names('show_edit', 'Edit');
                break;
            case 'show_edit':
                $this->show_edit_form();
                break;
            case 'do_edit':
                $this->do_edit();
                break;
            case 'del':
                $this->show_search('do_delete_search', 'Delete');
                break;
            case 'do_delete_search':
                $this->find_names('show_del', 'Delete');
                break;
            case 'show_del':
                $this->show_del();
                break;
            case 'do_del':
                $this->do_del();
                break;
            case 'val_mail':
                $this->show_val('Mail', 'mail');
                break;
            case 'do_val_mail':
                $this->do_val('mail');
                break;
            case 'val_admin':
                $this->show_val('Admin', 'admin');
                break;
            case 'do_val_admin':
                $this->do_val('admin');
                break;
            case 'massmail':
                $this->show_massmail();
                break;
            case 'do_massmail':
                $this->do_massmail();
                break;
			case 'ban':
				$this->show_ban();
				break;
			case 'do_ban':
				$this->do_ban();
				break;
            default:
                $admin->error("You have tried to use this file incorrectly. Please click a contents item on the left and try again.");
                break;
        }
    }

    function show_reg()
    {
        global $pa, $admin;

        $this->skin = $admin->add_top("Register", "Use the below form to create a site account.", "sites", "do_reg");
        $this->skin .= $admin->add_title("User Information", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Username:"), $admin->add_form_textbox("username", $pa->config["username"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Password:"), $admin->add_form_textbox("password", $pa->config["password"], 'pw')), 1);
        $this->skin .= $admin->add_td_row(array(array("E-Mail:"), $admin->add_form_textbox("email", $pa->config["email"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Site Name:"), $admin->add_form_textbox("site_name", $pa->config["site_name"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Site URL:"), $admin->add_form_textbox("site_url", $pa->config["site_url"])), 1);
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Register');
        $admin->do_output($this->skin);
    }

    function do_reg()
    {
        global $pa, $admin, $DB;

        if (strlen($pa->input['username']) < $pa->config['min_letters']) {
            $admin->error("Sorry, that username is to short");
        } else if (strlen($pa->input['password']) < $pa->config['min_letters']) {
            $admin->error("Sorry, that password is to short.");
        } else if ($pa->check_email($pa->input['email'])) {
            $admin->error("That e-mail is not invalid");
        } else if (strlen($pa->input['site_name']) < 2) {
            $admin->error("Your site name is to short");
        } else if (!preg_match("/http:\/\//", $pa->input['site_url'])) {
            $admin->error("That URL is invalid");
        } else if ($DB->count($DB->query("SELECT id FROM pa_users WHERE lower(username)='" . strtolower($pa->input['username']) . "'")) == 1) {
            $admin->error("Sorry, that username is taken");
        } else if ($pa->config['reg_check_mail'] == 1 AND $DB->count($DB->query("SELECT id FROM pa_users WHERE lower(email)='" . strtolower($pa->input['email']) . "'")) == 1) {
            $admin->error("Sorry, that e-mail is taken and you required unique e-mails in your registeration settings.");
        }

        $insert = array ('a_mail' => '1',
            'a_admin' => '1',
            'username' => $pa->input['username'],
            'password' => md5($pa->input['password']),
            'email' => $pa->input['email'],
            'site_name' => htmlspecialchars($pa->input['site_name'], ENT_QUOTES),
            'site_url' => htmlspecialchars($pa->input['site_url'], ENT_QUOTES),
            'date' => time(),
            );

        $insert = $DB->insert($insert);
        $DB->query("INSERT INTO pa_users ($insert[columns]) VALUES ($insert[values])");
        $admin->update("User Created Successfully", array("sites&op=reg" => 'Return to Registeration'));
    }

    function show_search($form, $title)
    {
        global $pa, $admin, $DB;

        $this->skin = $admin->add_top("$title Sites/Users", "Use the below form to search for user accounts. Place * at the end to make the term act as a wildcard. Whichever boxes you enter data into will become part of the search.", "sites", $form);
        $this->skin .= $admin->add_title("Search Terms", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Account ID:"), $admin->add_form_textbox("id")), 1);
        $this->skin .= $admin->add_td_row(array(array("Account Username:"), $admin->add_form_textbox("username")), 1);
        $this->skin .= $admin->add_td_row(array(array("User IP:"), $admin->add_form_textbox("ip_add")), 1);
        $this->skin .= $admin->add_td_row(array(array("E-Mail Address:"), $admin->add_form_textbox("email")), 1);
        $this->skin .= $admin->add_td_row(array(array("Site Name:"), $admin->add_form_textbox("site_name")), 1);
        $this->skin .= $admin->add_td_row(array(array("Site URL:"), $admin->add_form_textbox("site_url")), 1);
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Search');
        $admin->do_output($this->skin);
    }

    function find_names($form, $type)
    {
        global $pa, $admin, $DB;

		if(!is_numeric($pa->input['id']) AND $pa->input['id'] != "")
		{	 $admin->error("The site ID must be numeric.");	}

        $query = "SELECT id,username,site_name FROM pa_users WHERE ";
        if ($pa->input['id'] != "") $query_array[] = "id='" .$pa->input['id'] . "' ";
	    if ($pa->input['username'] != "") $query_array[] = "LOWER(username) LIKE '" . strtolower($pa->input['username']) . "%' ";
        if ($pa->input['ip_add'] != "") $query_array[] = "ip LIKE '" . $pa->create_ip($pa->input['ip_add']) . "' ";
        if ($pa->input['email'] != "") $query_array[] = "LOWER(email) LIKE '" . strtolower($pa->input['email']) . "%' ";
        if ($pa->input['site_name'] != "") $query_array[] = "LOWER(site_name) LIKE '%" . strtolower($pa->input['site_name']) . "%' ";
        if ($pa->input['site_url'] != "") $query_array[] = "LOWER(site_url) LIKE '%" . strtolower($pa->input['site_url']) . "%' ";

        if (!isset($query_array)) {
            $admin->error("You must enter at least one search term");
        }

        $query .= implode(" OR ", $query_array);
		$query .= " ORDER BY username ASC";
        $DB->query($query);

        if ($DB->count() == 0) {
            $admin->error("No accounts can be found with those search terms. Please try another search again.");
        }

        if ($DB->count() == '1') {
            $r = $DB->fetch_row();
            $pa->input['user'] = $r['id'];
            if ($form == 'show_edit') $this->show_edit_form();
			else $this->show_del();
        }

        $this->skin = $admin->add_top("Searching Accounts", "Select the account which you wish to <b>$type</b>.", "sites", $form);
        $this->skin .= $admin->add_title("Search Results", "2");
        $this->skin .= $admin->add_td_square("2");

        while ($r = $DB->fetch_row()) {
            $this->skin .= $admin->add_td_row(array($admin->add_form_radio('user', $r['id'], 1), $r['username'] . " <i>($r[site_name])</i>"), 3);
        }

        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end("$type Account");
        $admin->do_output($this->skin);
    }

    function show_edit_form()
    {
        global $pa, $admin, $DB;

        $DB->query("SELECT * FROM pa_users WHERE id='" . $pa->input['user'] . "'");

        if ($DB->count() != 1) {
            $admin->error("That account cannot be found");	}

        $row = $DB->fetch_row();

		foreach($row as $n => $v)
		{	$row[$n] = stripslashes($v);	}

        $this->skin = $admin->add_top("Edit Site/Users", "Edit the data below, when you are done press submit", "sites", "do_edit", '0', " enctype='multipart/form-data'");
        $this->skin .= $admin->add_form_hidden("user", $row['id']);
        $this->skin .= $admin->add_td_row(array('<br><b>IP Address:</b> ' . $pa->get_ip($row['ip']) . '', '<b>Signup Date:</b> ' . $pa->date($row['date'], 'mid')), 1);
        $this->skin .= $admin->add_title("Account Settings", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Username:"), $admin->add_form_textbox("username", $row['username'])), 1);
        $this->skin .= $admin->add_td_row(array(array("Password:", 'Leave empty unless you wish to reset it'), $admin->add_form_textbox("password", '', 'pw')), 1);
        $this->skin .= $admin->add_td_row(array(array("E-Mail Address:"), $admin->add_form_textbox("email", $row["email"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Site Name:"), $admin->add_form_textbox("site_name", $row["site_name"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Site Description:"), $admin->add_form_textbox("site_desc", $row["site_desc"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Site URL:"), $admin->add_form_textbox("site_url", $row["site_url"])), 1);
        $this->skin .= $admin->end_td_square();

        $this->skin .= $admin->add_title("Image Settings", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Site Banner:", 'If this has a URL in it, its a linked image, if it has an image extension its an upload otherwise it is no banner at all.'), $admin->add_form_textbox("site_banner", $row["site_banner"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Delete Uploaded Banner:", 'If this user has an uploaded image (shows an image extension above) press yes to delete it.'), $admin->add_form_radio("del_banner", '0')), 1);
        $this->skin .= $admin->add_td_row(array(array("Upload Banner:"), $admin->add_form_textbox("file", '0', 'file')), 1);
        $this->skin .= $admin->end_td_square();

        $this->skin .= $admin->add_title("Account Acceptance", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Banned:", 'Ban a user from the list'), $admin->add_form_radio("a_ban", $row['a_ban'])), 1);
        $this->skin .= $admin->add_td_row(array(array("E-Mail Accepted:"), $admin->add_form_radio("a_mail", $row['a_mail'])), 1);
        $this->skin .= $admin->add_td_row(array(array("Admin Accepted:"), $admin->add_form_radio("a_admin", $row['a_admin'])), 1);
        $this->skin .= $admin->add_td_row(array(array("Hide from List:", 'This is a user-selected option, users can still access User CP and reverse it. (If allowed in List Options)'), $admin->add_form_radio("a_hide", $row['a_hide'])), 1);
        $this->skin .= $admin->add_td_row(array(array("Account Validation Code:"), $admin->add_form_textbox("a_valkey", $row["a_valkey"])), 1);
        $this->skin .= $admin->add_td_row(array(array("Account Forget Password Code:"), $admin->add_form_textbox("a_valkey_pw", $row["a_valkey_pw"])), 1);
        $this->skin .= $admin->end_td_square();

        $this->skin .= $admin->add_end('Submit Changes');
        $admin->do_output($this->skin);
    }

    function do_edit()
    {
        global $pa, $admin, $DB;

        $DB->query("SELECT id,site_banner FROM pa_users WHERE id='" . $pa->input['user'] . "'");
        if ($DB->count() != 1) {
            $admin->error("That account cannot be found");
        }

        $r = $DB->fetch_row();

        if ($pa->input['del_banner'] == 1 AND $r['site_banner'] != "" AND $r['site_banner'] != '0' AND !preg_match("/http:\/\//", $r['site_banner'])) {
            unlink($pa->config['path_banners'] . $r['id'] . "." . $r['site_banner']);
            $unlink = 1;
        }

        foreach($pa->input as $n => $v) {
            if ($n == "code" OR $n == "source" OR strlen($n) <= '3'OR $n == "del_banner" OR $n == 'user' OR $n == "file" OR $v == "") {	continue;	}
            else {	$update[$n] = stripslashes($v);	}
        }

        $file = $pa->file("file");

        if ($file != '0') {
            $path = $pa->config['path_banners'] . $r['id'] . ".$file[ex]";

            copy($file['file'], $path) or die("The file could not be copied");
            $update['site_banner'] = $file['ex'];
        } else if (preg_match("/http:\/\//", $pa->input['site_banner'])) {
            $update['site_banner'] = $pa->input['site_banner'];
        } else if ($r['site_banner'] != $pa->input['site_banner'] OR $unlink == 1) {
            $update['site_banner'] = "";
        }

		$update['password'] = md5($pa->input['password']);

        $DB->query("UPDATE pa_users SET " . $DB->update($update) . " WHERE id='" . $pa->input['user']  . "'");

        $admin->update("Settings Updated Successfully", array("sites&op=edit&op=show_edit&user=$r[id]" => 'Edit same Account Again', "sites&op=edit" => 'Return to Account Editing'));
    }

    function show_del()
    {
        global $pa, $admin, $DB;
        $DB->query("SELECT id,username,site_name FROM pa_users WHERE id='" . $pa->input['user'] . "'");

        if ($DB->count() != 1) {
            $admin->error("That account cannot be found");
        }

        $row = $DB->fetch_row();

        $this->skin = $admin->add_top("Delete Account", "Use this page to delete an account", "sites", "do_del", '0');
        $this->skin .= $admin->add_form_hidden("user", $row['id']);
        $this->skin .= $admin->add_title("Delete Account", "2");
        $this->skin .= $admin->add_td_square("1");
        $this->skin .= $admin->add_td_row(array("Are you sure you wish to delete <b>$row[username] ($row[site_name])</b> account?"));
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end('Delete Account');
        $admin->do_output($this->skin);
    }
    function do_del()
    {
        global $pa, $admin, $DB;

        $DB->query("DELETE FROM pa_users WHERE id='" . $pa->input['user'] . "'");
        $admin->update("Account Deleted Successfully", array("sites&op=del" => 'Delete another Account'));
    }

    function show_val($type, $q)
    {
        global $pa, $admin, $DB;

        $DB->query("SELECT id,username FROM pa_users WHERE a_$q!='1'");

        if ($DB->count() == 0) {
            $admin->error("No accounts require $type Validation.");
        }

        $this->skin = $admin->add_top("Validate $type Accounts", "Press the button, and accept to automatically accept the account on your list.", "sites", "do_val_$q", '0');
        $this->skin .= $admin->add_title("Validate Results", "2");
        $this->skin .= $admin->add_td_square("2");

        while ($r = $DB->fetch_row()) {
            $this->skin .= $admin->add_td_row(array($admin->add_form_radio('user', $r['id'], 1), $r['username']), 3);
        }

        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end("Validate Account");
        $admin->do_output($this->skin);
    }

    function do_val($q)
    {	global $pa, $admin, $DB;

		if($q == "admin")
		{	$DB->query("SELECT a_mail FROM pa_users WHERE id='" . $pa->input['user'] . "'");
			$r = $DB->fetch_row();

			if($r['a_mail'] == 1 AND $pa->config['reg_email_info'] == 1)
			{
				$pa->lang_choice = $pa->config['lang_choice'];	// Base the e-mail around the default language
				$pa->load_lang("register");

				$mail['to_name'] = $r['username'];
				$mail['to_mail'] = $r['email'];
				$mail['subject'] = $pa->lang['reg_at'] . $pa->config['pa_name'];
				$mail['message'] = $pa->make_message(array("act" => "new_user_email", "username" => $r['username'], "password" => "You should know this!", "site_name" => $r['name'], "site_url" => $r['url']));
				$pa->mailer($mail);
			}
		}

        $DB->query("UPDATE pa_users SET a_$q='1' WHERE id='" . $pa->input['user'] . "'");
        $admin->update("Account Validated Successfully", array("sites&op=val_$q" => 'Validate another Account'));
    }

    function show_massmail()
    {	global $pa, $admin, $DB;

        $this->skin = $admin->add_top("Mass E-Mail Members", "If a user allows board administrator e-mails (set in User CP), this will e-mail them. The message will also be sent to the board owner, automatically.", "sites", "do_massmail", '0');
        $this->skin .= $admin->add_title("Enter Message", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Message Subject:"), $admin->add_form_textbox("subject")), 1);
        $this->skin .= $admin->add_td_row(array(array("Message:", "Enter your Message:"), $admin->add_form_textarea("message", '', '20'),), 1);
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end("Send Mail");
        $admin->do_output($this->skin);
    }

    function do_massmail()
    {	global $pa, $admin, $DB;

        $DB->query("SELECT username,email FROM pa_users WHERE allow_admin_mail=1 AND a_ban!=1");

        if ($DB->count() == 0) {
            $admin->error("No accounts are currently accepting e-mails");
        }

		$mail['subject'] = $pa->input['subject'];
        $mail['message'] = $pa->input['message'];


		$no = 0;
		$st = 1;
        while ($r = $DB->fetch_row()) {
            if($pa->check_email($r['email']))	continue;

			$mail['to_mail'] = $r['email'];
			$mail['to_name'] = $r['username'];
			$pa->mailer($mail);
		}

        $admin->update("E-Mail Sent Successfully", array("sites&op=massmail" => 'Send Another Message'));
    }

	function show_ban()
	{	global $pa, $admin, $DB;

		$banned_email = preg_replace("/,/", "\n", $pa->config['banned_email']);
		$banned_ip = preg_replace("/,/", "\n", $pa->config['banned_ip']);

		$this->skin = $admin->add_top("Ban Settings", "Use the below settings to ban IPs or E-Mail Addresses from using your boards.", "sites", "do_ban", '0');
        $this->skin .= $admin->add_title("Ban Input", "2");
        $this->skin .= $admin->add_td_square("2");
        $this->skin .= $admin->add_td_row(array(array("Banned IPs:", "Enter the IPs in the box, place one per line. Use * as a wildcard. ie. Use 125.33.* to ban all IPs starting with those numbers."), $admin->add_form_textarea("banned_ip", $banned_ip),), 1);
        $this->skin .= $admin->add_td_row(array(array("Banned E-Mails:", "Enter the e-mails into the box. Use * as a wildcard. ie. Use *@domain.com to ban all of that domain or monster@* to ban all e-mails which start with monster."), $admin->add_form_textarea("banned_email", $banned_email),), 1);
        $this->skin .= $admin->end_td_square();
        $this->skin .= $admin->add_end("Update Settings");
        $admin->do_output($this->skin);
	}

	function do_ban()
	{	global $pa, $admin, $DB;

		$update_email = preg_replace("/\n/", ",", $pa->input['banned_email']);
		$update_ip = preg_replace("/\n/", ",", $pa->input['banned_ip']);

		$DB->query("UPDATE pa_config SET banned_email='$update_email',banned_ip='$update_ip' WHERE id='".$DB->config[5]."'");

		$admin->update("Banned Settings Updated Successfully", array("sites&op=ban" => 'Edit Ban Settings Again'));

	}
}

?>