<?php
/***********************************************************************
/                      PhotoAlbum SQL Personal Edition                 *
/			   Code (C) Dan Osipov			       *
/			  E-mail: dan@osipov.org                       *
/                                                                      *
/    This is a fully functional version. Please do not edit this code, *
/    unless you know what you are doing.                               *
/                                                                      *
/    Please make sure to give me some feedback on this program.        *
/    Visit my website at http://dan.osipov.org/photosql/               *
/                                                                      *
/    Structure of the program borrowed from Monster's Top List         *
/                                                                      *
/**********************************************************************/

new Skin_Edit;

class Skin_Edit	{
	var $skin = array();
	var $desc = array();
	var $name_cach = array();
	var $skin_files = array();
	var $files = array();
	var $folders = array();

	function skin_edit()
	{	global $pa, $admin;

		$this->skin_files = array (
							'universal' => array (	'head' => '<b><i>Global Header</i></b>',
													'foot' => '<b><i>Global Footer</i></b>',
													'redirect' => 'Redirect Screen',
													'error' => 'Error Screen',
										),
							'list' => array (       'top' => 'Top Header',
                            						'categories_top' => 'Directories List Header',
													'categories_foot' => 'Directories List Footer',
													'start_table' => 'Start of Gallery Table',
													'listing' => 'Listing (Thumbnail)',
													'end_table' => 'End of Gallery Table',
													'foot' => 'Bottom Footer',
													'search_form1' => 'Search Form Top',
													'search_form2' => 'Search Form Bootom',

										),
							'info' => array (		'info' => 'Information Panel',
													'comments_top' => 'Comments Top',
													'comments_middle' => 'Comments Middle',
													'comments_foot' => 'Comments Footer',
										),
							'misc' => array (		'rate' => 'Rate Popup',
 									    ),
                            'main' => array (		'main' => 'Main Page',
                            			),
		);

		$this->desc = array('info' => '<b>Information</b> (Info Panel, Comments)',
							'list' => '<b>Gallery</b> (Gallery List)',
							'misc' => '<b>Miscellaneous</b> (Rate)',
							'universal' => '<b>Universal</b> (Headers, Footers, Redirect, Error)',
                            'main' => '<b>Main Page</b>',
		);

		$skins = explode("|", $pa->config['skin_names']);

		foreach($skins as $n)
		{	$new_skin = explode(":", $n);
			$id_cach[$new_skin[0]] = 'x';
			$this->name_cach[$new_skin[0]] = $new_skin[1];
		}

		switch($pa->input['op'])
		{	case 'manageskin':
				$this->show_skins();
				break;
			case 'default':
				$this->do_default();
				break;
			case 'edit':
				$this->show_skin_files();
				break;
			case 'rename_skin':
				$this->rename_skin();
				break;
			case 'show':
				$this->show_skins_data();
				break;
			case 'prev':
				$this->show_prev();
				break;
			case 'do_skin':
				$this->do_skin();
				break;
			case 'add_skin':
				$this->do_add_skin();
				break;
			case 'del':
				$this->show_del();
				break;
			case 'do_del':
				$this->do_del();
				break;
			case 'export':
				$this->export();
				break;
			case 'download':
				$this->export_dl();
				break;
			case 'importskin':
				$this->show_import();
				break;
			case 'import_skin':
				$this->do_import();
				break;
			case 'upload':
				$this->show_upload();
				break;
			case 'upload_skin':
				$this->do_upload();
				break;
		}
	}

	function do_upload()
	{	global $admin, $pa, $DB, $root_path;

		$file = $pa->file("upload");

		if(!preg_match("/^skin_/", $file['name']) OR !preg_match("/.tar$/", $file['name']))
		{	$admin->error("That file is invalid.");	}

		if(!isset($pa->input['name']) OR $pa->input['name'] == "")
		{	$admin->error("You must enter a name for your new skin."); 	}

		if(preg_match("/:/", $pa->input['name']) OR preg_match("/\|/", $pa->input['name']))
		{	$admin->error("':' or '|' cannot be entered in the skin name.");	}

		require($root_path."sources/lib_tar.php");	// Matthew Mecham's WONDERFUL Tar Script

		$tar = new tar();
		$tar->new_tar("", $file['file']);
		if($tar->error != "")		{	$admin->error($tar->error); 	}
		$files = $tar->list_files();
		if($tar->error != "")		{	$admin->error($tar->error); 	}
		if (!$pa->check_archive($files) )		{	$admin->error("That is not a valid tar-achive, please re-upload in binary and try again");	}

		$id = count($this->name_cach) + 1;

		if(!mkdir($root_path."skin/s{$id}", 0777))
		{	$admin->error("Unable to create directory, please make sure the directory 'skin' is CHMOD '777'.");	}
		@chmod($root_path."skin/s{$id}", 0777);

		$tar->extract_files($root_path."skin/s{$id}");
		if($tar->error != "")		{	$admin->error($tar->error); 	}

		$this->name_cach[$id] = $pa->input['name'];

		foreach($this->name_cach as $n => $v)
		{	$save_skin[] = $n.":".$v;		}
			$skins = implode("|", $save_skin);

		$DB->query("UPDATE pa_config SET skin_names='$skins'");

		$admin->update("Skin Added Successfully", array("skin&op=edit&id=$id" => "Edit New Skin", "skin&op=manageskin" => 'Return to Main Skins'));

	}

	function show_upload()
	{	global $admin, $pa, $DB, $root_path;

		$this->skin = $admin->add_top("Import/Upload Skin Packs", "This page will allow you to import skin packs from your computer hard drive.", "skin", "upload_skin", '0', "enctype='multipart/form-data'");
        $this->skin .= $admin->add_title("Import Skin Pack", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("New Skin Name:", "ie. 'Green' or 'Hanukah'"), $admin->add_form_textbox("name")), 1);
		$this->skin .= $admin->add_td_row(array(array("Select File:"), "<input type='file' name='upload' class='textinput'>"), 1);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Upload/Import Skin');
		$admin->do_output($this->skin);
	}

	function do_import()
	{	global $admin, $pa, $DB, $root_path;

		if(!isset($pa->input['name']) OR $pa->input['name'] == "")
		{	$admin->error("You must enter a name for your new skin."); 	}

		if(preg_match("/:/", $pa->input['name']) OR preg_match("/\|/", $pa->input['name']))
		{	$admin->error("':' or '|' cannot be entered in the skin name.");	}

		require($root_path."sources/lib_tar.php");	// Matthew Mecham's WONDERFUL Tar Script

		$path = $root_path."tars";

		$tar = new tar();
		$tar->new_tar($path, $pa->input['pack']);
		if($tar->error != "")		{	$admin->error($tar->error); 	}
		$files = $tar->list_files();
		if($tar->error != "")		{	$admin->error($tar->error); 	}
		if (!$pa->check_archive($files) )		{	$admin->error("That is not a valid tar-achive, please re-upload in binary and try again");	}

		$id = count($this->name_cach) + 1;
		if(!mkdir($root_path."skin/s{$id}", 0777))
		{	$admin->error("Unable to create directory, please make sure the directory 'skin' is CHMOD '777'.");	}
		@chmod($root_path."skin/s{$id}", 0777);

		$tar->extract_files($root_path."skin/s{$id}");
		if($tar->error != "")		{	$admin->error($tar->error); 	}

		$this->name_cach[$id] = $pa->input['name'];

		foreach($this->name_cach as $n => $v)
		{	$save_skin[] = $n.":".$v;		}
			$skins = implode("|", $save_skin);

		$DB->query("UPDATE pa_config SET skin_names='$skins'");

		$admin->update("Skin Added Successfully", array("skin&op=edit&id=$id" => "Edit New Skin", "skin&op=manageskin" => 'Return to Main Skins'));
	}

	function show_import()
	{	global $admin, $pa, $root_path;

		$id = 0;
		$dir = opendir($root_path."tars/");
		while($filename = readdir($dir))
		{	if ($filename != "." AND $filename != "..")
			{	if(preg_match("/^skin_/", $filename))
  				{	$id++;
					$names[] = $filename;
				}
  			}
		}
		closedir($dir);

		$this->skin = $admin->add_top("Import Skins Packs", "This page will allow you to import skin packs from the 'tars' directory.<br><br><b><a href='admin.php?s={$pa->session}&act=skin&op=upload'>Upload a Skin Pack</a></b>", "skin", "import_skin");
        $this->skin .= $admin->add_title("Import Skin Pack", "2");
		$this->skin .= $admin->add_td_square("2");
		if($id == 0)
		{	$this->skin .= $admin->add_td_row(array("Sorry, no skin packs can be found in the 'tars' directory."), 1);	}
		else {
		$this->skin .= $admin->add_td_row(array(array("New Skin Name:", "ie. 'Green' or 'Hanukah'"), $admin->add_form_textbox("name")), 1);
		$this->skin .= $admin->add_td_row(array(array("Pack to Export:"), $admin->add_dropdown("pack", $names, 2)), 1);	}
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Import Skin');
		$admin->do_output($this->skin);

	}

	function export_dl()
	{	global $pa, $root_path;

		// Simple and works!
		header("Location: tars/{$pa->input['id']}");
		exit;
	}

	function export()
	{	global $admin, $pa, $DB, $root_path;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skin cannot be found."); 	}

		require($root_path."sources/lib_tar.php");	// Matthew Mecham's Tar Script

		$name = "skin_".str_replace(" ", "_", $this->name_cach[$pa->input['id']])."_".time().".tar";

		$tar = new tar();
		$tar->new_tar($root_path."tars", $name);
		if($tar->error != "")		{	$admin->error($tar->error); 	}
		$tar->add_directory($root_path."skin/s{$pa->input['id']}");
		if($tar->error != "")		{	$admin->error($tar->error); 	}
		$tar->write_tar();
		if($tar->error != "")		{	$admin->error($tar->error); 	}
		$admin->update("Skin Backed Up Successfully into 'out' directory", array("skin&op=download&id=$name" => "Download Skin Pack", "skin&op=manageskin" => 'Return to Main Skins'));

	}

	function do_del()
	{	global $admin, $pa, $root_path, $DB;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skin cannot be found."); 	}

		if(count($this->name_cach) == 1)
		{	$admin->error("Sorry, you must have at least one skin installed.");	}

		$backup = $this->file_names("skin/s{$pa->input['id']}/");

		foreach($backup['files'] as $v)
		{	unlink($root_path."skin/s{$pa->input['id']}/$v");	}

		foreach($backup['dirs'] as $v)
		{	rmdir($root_path."skin/s{$pa->input['id']}/$v");	}

		rmdir($root_path."skin/s{$pa->input['id']}");

		foreach($this->name_cach as $n => $v)
		{	if($pa->input['id'] == $n)
			{	continue;	}
			if(!isset($save_skin)){	$safe_default = $n;	}
			$save_skin[] = $n.":".$v;		}
			$skins = implode("|", $save_skin);

		if($pa->config['skin_choice'] == $pa->input['id'])
		{	$default = ",skin_choice='$safe_default'";	}

		$DB->query("UPDATE pa_config SET skin_names='$skins'$default");

		$admin->update("Skin Deleted Successfully", array("skin&op=manageskin" => 'Return to Main Skins'));
	}

	function show_del()
	{	global $admin, $pa;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skin cannot be found."); 	}

		if(count($this->name_cach) == 1)
		{	$admin->error("Sorry, you must have at least one skin installed.");	}

		$this->skin = $admin->add_top("Delete Skin", "Use this page to delete a skin", "skin", "do_del", '0');
        $this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
      	$this->skin .= $admin->add_title("Delete Skin", "2");
        $this->skin .= $admin->add_td_square("1");
        $this->skin .= $admin->add_td_row(array("Are you sure you wish to delete <b>{$this->name_cach[$pa->input['id']]}</b>?"));
        $this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Delete Skin');

		$admin->do_output($this->skin);
	}

	function do_add_skin()
	{	global $admin, $pa, $root_path, $DB;

		if(!isset($pa->input['name']) OR $pa->input['name'] == "")
		{	$admin->error("You must enter a name for your new skin."); 	}

		if(preg_match("/:/", $pa->input['name']) OR preg_match("/\|/", $pa->input['name']))
		{	$admin->error("':' or '|' cannot be entered in the skin name.");	}

		$id = count($this->name_cach) + 1;

		if(!mkdir($root_path."skin/s{$id}", 0777))
		{	$admin->error("Unable to create directory, please make sure the directory 'skin' is CHMOD '777'.");	}

		@chmod($root_path."skin/s{$id}", 0777);

		$backup = $this->file_names("skin/s{$pa->input['base']}/");

		foreach($backup['dirs'] as $v)
		{	mkdir($root_path."skin/s{$id}/$v", 0777);
			@chmod($root_path."skin/s{$id}/$v", 0777);	}

		foreach($backup['files'] as $v)
		{	copy($root_path."skin/s{$pa->input['base']}/$v", $root_path."skin/s{$id}/$v");
			@chmod($root_path."skin/s{$id}/$v", 0777);	}

		$this->name_cach[$id] = $pa->input['name'];

		foreach($this->name_cach as $n => $v)
		{	$save_skin[] = $n.":".$v;		}
			$skins = implode("|", $save_skin);

		$DB->query("UPDATE pa_config SET skin_names='$skins'");

		$admin->update("Skin Added Successfully", array("skin&op=edit&id=$id" => "Edit New Skin", "skin&op=manageskin" => 'Return to Main Skins'));
	}


	function show_prev()
	{	global $admin, $pa, $root_path;

		if ( $open = fopen( $root_path."skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php", 'r' ) )
		{	$text = fread($open, filesize($root_path."skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php"));
		 	fclose($open);	}
		else
		{	$admin->error("Cannot view skin file, please make sure skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php is CHMOD 777");		}

		if ( $open = fopen( $root_path."skin/s{$pa->input['id']}/sources/universal.php", 'r' ) )
		{	$text2 = fread($open, filesize($root_path."skin/s{$pa->input['id']}/sources/universal.php"));
		 	fclose($open);	}
		else
		{	$admin->error("Cannot view skin file, please make sure skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php is CHMOD 777");		}

		$style = $this->extract_function('head', $text2, 1);

		$style = preg_replace('/(.*?)<style>(.*?)<\/style>(.*)/is', "<style>\\2</style>", $style);
		$data = $this->extract_function($pa->input['sec'], $text, 1);

		$pa->skin_choice = $pa->input['id'];

		$data = preg_replace("/\{".'\$pa'."-\>skin\['(.*?)'\]\}/", "{pa.skin(\\1)}", $data);
		$data = preg_replace("/\{".'\$(.*?)'."\['(.*?)'\]\}/", "{\\1(\\2)}", $data);
		$data = preg_replace("/\['(.*?)'\]/", "[\\1]", $data);
		// Let's deal with redirect screens
		$data = preg_replace("/<meta http-equiv='refresh' content='(.*?); url=(.*?)}'>/", "", $data);
		eval ('$data2 = "'.addslashes($data).'";');
		$data = stripslashes($data2);

$output = <<<data
<head>
$style
</head>
<body>
$data
</body>
data;
		$skin = new Skins;
		$skin->simple($output);
	}

	function do_skin()
	{	global $admin, $pa, $root_path;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skinuage cannot be found."); 	}

		if (!$open = fopen($root_path."skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php", 'r' ) )
		{	$admin->error("Cannot edit skin file, please make sure skin/sources/l{$pa->input['id']}/{$pa->input['f']}.php is CHMOD 777");		}

		$text = fread($open, filesize($root_path."skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php"));
		fclose($open);

		$old = $this->extract_function($pa->input['sec'], $text, 1);

		$new = stripslashes("\r".stripslashes($pa->input['data']));	// Process the input
		$new = preg_replace("/(\n)/is", "", $new);	// Don't want to show double spacing
		$new .= "\n";	// We need to seperate the bottom with a \n...damn PHP
		// Reverse the pretty variables into real variables!
		$new = preg_replace("/{([a-z0-9_]+)\(([a-z0-9_]+)\)}/i", "{".'$'."\\1['\\2']}", $new);
		$new = preg_replace("/{([a-z0-9_]+)\.([a-z0-9_]+)}/i", "{".'$'."\\1->\\2}", $new);
		$new = preg_replace("/{([a-z0-9_]+)\.([a-z0-9_]+)\(([a-z0-9_]+)\)}/i", "{".'$'."\\1->\\2['\\3']}", $new);
		$text = str_replace($old, $new, $text);	// Replace the old with the new and then output

		$open = fopen($root_path."skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php", 'w');
		fwrite($open, $text, strlen($text));
		fclose($open);	// Save our new file... and we're done

		$admin->update("Skin Updated Successfully", array("skin&op=show&id={$pa->input['id']}&f={$pa->input['f']}&sec={$pa->input['sec']}" => 'Return to edit this Skin file again', "skin&op=edit&id={$pa->input['id']}&expand={$pa->input['f']}" => 'Return to this Skins\'s main editing screen', "skin&op=manageskin" => 'Return to Manage Skins' ));
	}

	function show_skins_data()
	{	global $admin, $pa, $root_path;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skin cannot be found."); 	}

		if ( $open = fopen( $root_path."skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php", 'r' ) )
		{	$text = fread($open, filesize($root_path."skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php"));
		 	fclose($open);	}
		else
		{	$admin->error("Cannot edit skin file, please make sure skin/s{$pa->input['id']}/sources/{$pa->input['f']}.php is CHMOD 777");		}

		$text = $this->extract_function($pa->input['sec'], $text);
		$text = htmlspecialchars($text, ENT_QUOTES);
		$text = preg_replace("/(\r|\n)$/", "", $text);

		$this->skin = $admin->add_top("Edit Skin Data", "Edit the text below to change the skin.", "skin", 'do_skin');
		$this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
	    $this->skin .= $admin->add_form_hidden("f", $pa->input['f']);
		$this->skin .= $admin->add_form_hidden("sec", $pa->input['sec']);
		$this->skin .= $admin->add_title("Edit Skin - {$this->name_cach[$pa->input['id']]} - {$pa->input['f']} - {$this->skin_files[$pa->input['f']][$pa->input['sec']]}", "2");
        $this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array("<a href=\"javascript:popup('admin.php?s={$pa->session}&act=skin&op=prev&id={$pa->input['id']}&f={$pa->input['f']}&sec={$pa->input['sec']}',700,500)\">Preview this Skin File</a><br><a href='admin.php?s={$pa->session}&act=skin&op=edit&id={$pa->input['id']}&expand={$pa->input['f']}'>Back to Skin Editing</a>"));
		$this->skin .= $admin->add_td_row(array("<b>$n</b>", $admin->add_form_textarea('data', $text, '30', '90')), 2);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Edit Skin');
        $admin->do_output($this->skin);
	}

	function rename_skin()
	{	global $admin, $pa, $DB;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skin cannot be found."); 	}

		if(!isset($pa->input['name']) OR $pa->input['name'] == "")
		{	$admin->error("You must enter a name for your new skin."); 	}

		if(preg_match("/:/", $pa->input['name']) OR preg_match("/\|/", $pa->input['name']))
		{	$admin->error("':' or '|' cannot be entered in the skin name.");	}

		foreach($this->name_cach as $n => $v)
		{	if($pa->input['id'] == $n)
			{	$v = $pa->input['name'];	}
			$save_skin[] = $n.":".$v;	}

		$skins = implode("|", $save_skin);
		$DB->query("UPDATE pa_config SET skin_names='$skins'");
		$admin->update("Skin Renamed Successfully", array("skin&op=edit&id={$pa->input['id']}" => "Edit Same Skin", "skin&op=manageskin" => 'Return to Main Skins'));
	}

	function show_skin_files()
	{	global $admin, $pa;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skin cannot be found."); 	}

		if(isset($pa->input['expand']) AND $pa->input['expand'] != "")
		{	$open = explode(",", $pa->input['expand']);	}
		else	{	$open = array();	}

		$this->skin = $admin->add_top("Edit Skin Packs", "Select which area you wish to edit. Major editing points are bolded and italiced.", "skin", "rename_skin");
        $this->skin .= $admin->add_title("Edit Skins - {$this->name_cach[$pa->input['id']]}", "2");
        $this->skin .= $admin->add_td_square("2");

		foreach($this->skin_files as $n => $v)
		{	$rewrite = $open;

			if(in_array($n, $open))
			{	$show_position = "Compact";
				foreach($rewrite as $n2 => $v2)
				{	if($v2 == $n)
					{	unset($rewrite[$n2]);
						break;	}
				}
			}
			else {	$show_position = "Expand";
					$rewrite[] = $n;			}

			$rewrite = implode(",", $rewrite);
			$this->skin .= $admin->add_td_row(array($this->desc[$n], "<a href='admin.php?s={$pa->session}&act=skin&op=edit&id={$pa->input['id']}&expand=$rewrite'>$show_position</a>"), 4);

			if($show_position == "Compact")
			{	foreach($v as $n2 => $v2)
				{	$this->skin .= $admin->add_td_row(array("<blockquote>".$v2."</blockquote>", "<a href='admin.php?s={$pa->session}&act=skin&op=show&id={$pa->input['id']}&f=$n&sec=$n2'>Edit</a> | <a href=\"javascript:popup('admin.php?s={$pa->session}&act=skin&op=prev&id={$pa->input['id']}&f=$n&sec=$n2',700,500)\">View</a>"), 4);	}
			}
		}
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_title("Rename Skin", "2");
		$this->skin .= $admin->add_form_hidden("id", $pa->input['id']);
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("New Skin Name:", "ie. 'Green' or 'Hanukah'"), $admin->add_form_textbox("name", $this->name_cach[$pa->input['id']])), 1);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Rename Skin');

        $admin->do_output($this->skin);
	}

	function do_default()
	{	global $pa, $admin, $DB;

		if(!isset($this->name_cach[$pa->input['id']]))
		{	$admin->error("That skin cannot be found."); 	}

		$DB->query("UPDATE pa_config SET skin_choice='{$pa->input['id']}'");

		$admin->update("Default Skin Changed Successfully", array("skin&op=manageskin" => 'Return to Main Skins'));
	}

	function show_skins()
	{	global $pa, $admin;

		$this->skin = $admin->add_top("Manage Skins", "This page will allow you to add, edit or remove skin packs.", "skin", "add_skin");
        $this->skin .= $admin->add_title("Edit Skins", "2");
        $this->skin .= $admin->add_td_square("2");

		foreach($this->name_cach as $n => $v)
		{	if($pa->config['skin_choice'] == $n)
			{	$default = "<b>Current Default Skin</b>";	}
			else	{	$default = "<a href='admin.php?s={$pa->session}&act=skin&op=default&id=$n'>Make Default Skin</a>";	}

			$this->skin .= $admin->add_td_row(array("<b>$v</b>", "$default | <a href='admin.php?s={$pa->session}&act=skin&op=edit&id=$n'>Edit</a> | <a href='admin.php?s={$pa->session}&act=skin&op=del&id=$n'>Delete</a> | <a href='admin.php?s={$pa->session}&act=skin&op=export&id=$n'>Export</a>"), 2);
		}

		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_title("Add Skin", "2");
		$this->skin .= $admin->add_td_square("2");
		$this->skin .= $admin->add_td_row(array(array("New Skin Name:", "ie. 'Green' or 'Hanukah'"), $admin->add_form_textbox("name")), 1);
		$this->skin .= $admin->add_td_row(array(array("Base Skin On:"), $admin->add_dropdown("base", $this->name_cach, 1)), 1);
		$this->skin .= $admin->end_td_square();
		$this->skin .= $admin->add_end('Add Skin');
		$admin->do_output($this->skin);
	}

	function extract_function($sec, $text, $sit=0)
	{	$text = preg_replace("/(.*?)function {$sec}(.*?)<<<skin(.*?)skin;(.*)/is", "\\3", $text);

		if($sit != 1)	{	// Unfortunatly open variables cannot be used for these. It neesd to be a little more precise :(
		// Convert $pa->config['var'] to {pa.config(var)}
		$text = preg_replace("/\{".'\$([a-z0-9_]+)'."-\>([a-z0-9_]+)\['([a-z0-9_]+)'\]\}/i", "{\\1.\\2(\\3)}", $text);
		// Convert $pa->car to {pa.var)}
		$text = preg_replace("/\{".'\$([a-z0-9_]+)'."-\>([a-z0-9_]+)\}/i", "{\\1.\\2}", $text);
		// Convert $data['var'] to {data(var)}
		$text = preg_replace("/\{".'\$([a-z0-9_]+)'."\['([a-z0-9_]+)'\]\}/i", "{\\1(\\2)}", $text);	}

		return $text;
	}

	function file_names($path, $inside_dir="")
	{	global $pa, $root_path;

		$dir = opendir($root_path.$path);
		while($filename = readdir($dir))
		{	if ($filename != "." AND $filename != "..")
			{	if(!preg_match("/\./", $filename))
				{	$this->file_names($path.$filename."/", $inside_dir.$filename."/");
					$this->folders[] = $inside_dir.$filename;
				}
				else
				{	$this->files[] = $inside_dir.$filename;	}
  			}
		}
		closedir($dir);

		return array (	'dirs' => $this->folders,
						'files' => $this->files,
		);

	}
}

?>